1	REM TABELLENGENERIERUNG ELZET TASTATUR
2	REM ==================================
3	REM 31.5.85
4	REM Programmanpassung
5	REM -----------------
6	REM
7	REM In der vorliegenden Version ist das Programm fuer MBASIC unter
8	REM CP/M geschrieben.
9	REM
10	REM Tabellenformat
11	REM --------------
12	REM
13	REM Insgesamt werden 2048+256 Byte an Tabelle generiert Sie sind
14	REM im Tastatureprom ab der Adresse 0700H einzuubinden. Auf allen
15	REM durch 256 teilbaren Adressen wird automatisch die Sequenz 0A3H,
16	REM 083H eingefuegt. Die ersten 32 Byte sind Zeiger auf die einzel-
17	REM nen Startbereiche der Stringketten. Alle Stringketten bestehen
18	REM aus je 38 Eintraegen.
19	REM
20	REM
21	REM Variablenvereinbarungen
22	REM -----------------------
23	REM
24	DIM ROM%(2303)
25	REM
26	REM Fehlerbehandlung
27	REM ----------------
28	REM
29	ON ERROR GOTO 31
30	GOTO 32
31	ERTYP%=9:GOTO 71
32	REM
33	REM Hauptprogramm
34	REM -------------
35	REM
36	PRINT "--------------------------------------"
37	PRINT "Tastatur Tabellenerzeugung Version 1.1"
38	PRINT "(C) 1984              by ELZET 80 GmbH"
39	PRINT "--------------------------------------"
40	PRINT
41	GOSUB 338 : REM Initialisiere rom%
42	INPUT "Eingabedatei --> ",EINGABE$
43	FOR I%=1 TO LEN(EINGABE$)
44	IF MID$(EINGABE$,I%,1)<"a" OR MID$(EINGABE$,I%,1)>"z" THEN GOTO 46
45	MID$(EINGABE$,I%,1)=CHR$(ASC(MID$(EINGABE$,I%,1))-32)
46	NEXT I%
47	INPUT "ROM-Datei --> ",AUSGABE$
48	FOR I%=1 TO LEN(AUSGABE$)
49	IF MID$(AUSGABE$,I%,1)<"a" OR MID$(AUSGABE$,I%,1)>"z" THEN GOTO 51
50	MID$(AUSGABE$,I%,1)=CHR$(ASC(MID$(AUSGABE$,I%,1))-32)
51	NEXT I%
52	OPEN "O",#2,AUSGABE$
53	OPEN "I",#1,EINGABE$
54	PRINT
55	IF EOF(1) GOTO 62
56	LINE INPUT #1,EZEILE$
57 	PRINT EZEILE$
58	EZEILE$=EZEILE$+CHR$(0)
59	IF MID$(EZEILE$,1,1)=";" OR MID$(EZEILE$,1,1)=CHR$(0) THEN GOTO 55
60	GOSUB 92 : REM Analyse der Eingabezeile
61	GOTO 55
62	FOR I%=0 TO 2303 STEP 1
63	PRINT #2,CHR$(ROM%(I%));
64	NEXT I%
65	CLOSE #2
66	GOTO 353
67	REM
68	REM Fehlerausgaben
69	REM --------------
70	REM
71	PRINT:PRINT
72	ON ERTYP% GOTO 74,75,76,83,84,85,86,87,88,89,90,91
73	PRINT "***Illegale Fehlermeldung***":GOTO 353
74	PRINT "***Eingabedatei nicht zu oeffnen***":GOTO 353
75	PRINT "***Ausgabedatei nicht zu oeffnen***":GOTO 353
76	PRINT "***Illegale Eingabezeile***"
77	PRINT STRING$(79,"-")
78	PRINT EZEILE$
79	FOR I%=1 TO PS%-2:PRINT " ";:NEXT I%
80	PRINT "^"
81	PRINT STRING$(79,"-")
82	GOTO 353
83	PRINT "***Taste bereits definiert***":GOTO 353
84	PRINT "***Speicherueberlauf***":GOTO 353
85	PRINT "***Interner Fehler***":GOTO 353
86	PRINT "***Illegales Steuerzeichen***":GOTO 353
87	PRINT "***Falsches HEX Digit***":GOTO 353
88	PRINT "***Interner Basic Fehler (Datei ueberpruefen)***":GOTO 353
89	PRINT "***Zeichenkette zu lang***":GOTO 353
90	PRINT "***Zuordnung auf belegte Betriebsart***":GOTO 353
91	PRINT "***Illegales Zeilenende***":GOTO 353
92	REM
93	REM Analyse einer Eingabezeile
94	REM --------------------------
95	REM
96	REM Die Eingabezeile in zeile$ wird in eine Zeichenkette umge-
97	REM setzt. Die Variable MODE%,KEY%,LEVEL% werden entsprechend
98	REM gesetzt.
99	REM
100	PS%=1
101	GOSUB 175
102	IF CH$ <> "P" THEN GOTO 112
103	GOSUB 175
104	GOSUB 187
105	IF X% < 1 OR X% > 16 THEN ERTYP%=3:GOTO 67
106	KEY%=X%-1
107	GOSUB 195
108	GOSUB 215
109	GOSUB 257
110	GOSUB 264
111	RETURN
112	IF CH$ <> "E" THEN GOTO 126
113	GOSUB 175
114	GOSUB 195
115	EMDE%=MDE%:ELEVEL%=LEVEL%
116	IF CH$<>"=" THEN ERTYP%=3:GOTO 71
117	GOSUB 175
118	GOSUB 195
119	GOSUB 257
120	IDXOF%=2+ELEVEL%*8+EMDE%*2
121	IF (ROM%(IDXOF%) AND &H1F)<>0 OR ROM%(IDXOF%+1)<>34 THEN ERTYP%=11:GOTO 71
122	IDXPG%=2+LEVEL%*8+MDE%*2
123	ROM%(IDXOF%)=ROM%(IDXPG%)
124	ROM%(IDXOF%+1)=ROM%(IDXPG%+1)
125	RETURN
126	IF CH$ <> "C" THEN GOTO 136
127	GOSUB 175
128	GOSUB 187
129	IF X% < 1 OR X% > 8 THEN ERTYP%=3:GOTO 67
130	KEY%=15+X%
131	GOSUB 195
132	GOSUB 215
133	GOSUB 257
134	GOSUB 264
135	RETURN
136	IF CH$<>"M" THEN GOTO 157
137	GOSUB 175
138	GOSUB 195
139	IF CH$<>"=" THEN ERTYP%=3:GOTO 71
140	GOSUB 175
141	MSK%=224
142	IF CH$="1" THEN MSK%=MSK% AND &H7F:GOTO 145
143	IF CH$="0" THEN GOTO 145
144	ERTYP%=3:GOTO 71
145	GOSUB 175
146	IF CH$="1" THEN MSK%=MSK% AND &HBF:GOTO 149
147	IF CH$="0" THEN GOTO 149
148	ERTYP%=3:GOTO 71
149	GOSUB 175
150	IF CH$="1" THEN MSK%=MSK% AND &HDF:GOTO 153
151	IF CH$="0" THEN GOTO 153
152	ERTYP%=3:GOTO 71
153	GOSUB 175:GOSUB 257
154	IDXOF%=2+LEVEL%*8+MDE%*2
155	ROM%(IDXOF%)=(ROM%(IDXOF%) AND &H1F) OR MSK%
156	RETURN
157	IF CH$ <> "N" THEN ERTYP%=3 : GOTO 67
158	GOSUB 175
159	GOSUB 187
160	IF X% < 1 OR X% > 14 THEN ERTYP%=3:GOTO 67
161	KEY%=23+X%
162	GOSUB 195
163	GOSUB 215
164	GOSUB 257
165	GOSUB 264
166	RETURN
167	REM
168	REM Lese naechstes Zeichen nach CH$
169	REM -------------------------------
170	REM
171	IF PS% > LEN(EZEILE$) THEN ERTYP%=3 : GOTO 67
172	CH$ = MID$(EZEILE$,PS%,1)
173	PS%=PS%+1
174	RETURN
175	REM
176	REM Lese naechstes Zeichen nach CH$ (Grossschrift)
177	REM ----------------------------------------------
178	REM
179	GOSUB 167
180	IF CH$=" " OR CH$=CHR$(9) THEN GOTO 179
181	IF CH$>="a" AND CH$<="z" THEN CH$=CHR$(ASC(CH$)-32)
182	RETURN
183	REM
184	REM Lese Zahl ein
185	REM -------------
186	REM
187	X%=0
188	IF CH$ >= "0" AND CH$ <= "9" THEN X%=10*X%+ASC(CH$)-ASC("0") ELSE RETURN
189	GOSUB 175
190	GOTO 188
191	REM
192	REM Lese ID in Klammern ein
193	REM -----------------------
194	REM
195	IF CH$ <> "(" THEN ERTYP%=3 : GOTO 67
196	GOSUB 175
197	CASE$=CH$
198	GOSUB 175
199	CASE$=CASE$+CH$
200	GOSUB 175
201	IF CASE$ = "SC" THEN MDE%=0 : GOTO 206
202	IF CASE$ = "CC" THEN MDE%=1 : GOTO 206
203	IF CASE$ = "UC" THEN MDE%=2 : GOTO 206
204	IF CASE$ = "LC" THEN MDE%=3 : GOTO 206
205	ERTYP%=3 : GOTO 67
206	LEVEL%=ASC(CH$)-ASC("0")
207	IF LEVEL%<0 OR LEVEL%>3 THEN ERTYP%=3 : GOTO 67
208	GOSUB 175 : IF CH$ <> ")" THEN ERTYP%=3 : GOTO 67
209	GOSUB 175
210	RETURN
211	REM
212	REM Lese Zeichenkette in '"' nach STRG$
213	REM -----------------------------------
214	REM
215	SMD%=0
216	STRG$=""
217	REM Erstes Zeichen muss Apostroph sein
218	GOSUB 175
219	IF CH$ <> CHR$(34) THEN ERTYP%=3:GOTO 67
220	REM Zeichenleseschleife
221	IF LEN(STRG$)>254 THEN ERTYP%=10:GOTO 71
222	GOSUB 167
223	REM Normalzeichen
224	IF SMD% <> 0 THEN GOTO 231
225	IF CH$ = "^" THEN SMD%=1:GOTO 220
226	IF CH$ = "$" THEN SMD%=2:GOTO 220
227	IF CH$ = CHR$(34) THEN SMD%=4:GOTO 220
228	IF ASC(CH$) < 32 OR ASC(CH$) > 127 THEN ERTYP%=7:GOTO 67
229	STRG$=STRG$+CH$
230	GOTO 220
231	REM Control Zeichen
232	IF SMD% <> 1 THEN GOTO 237
233	IF CH$ = "^" THEN STRG$=STRG$+CH$:SMD%=0:GOTO 220
234	STRG$=STRG$+CHR$(ASC(CH$) AND &H1F)
235	SMD%=0
236	GOTO 220
237	REM Erstes Hex-Digit
238	IF SMD% <> 2 THEN GOTO 245
239	IF CH$ = "$" THEN STRG$=STRG$+CH$:SMD%=0:GOTO 220
240	IF CH$>="0" AND CH$<="9" THEN HX%=ASC(CH$)-ASC("0"):GOTO 243
241	IF CH$>="A" AND CH$<="F" THEN HX%=ASC(CH$)-ASC("A")+10:GOTO 243
242	ERTYP%=8:GOTO 67
243	SMD%=3
244	GOTO 220
245	REM Zweites Hex-Digit
246	IF SMD% <> 3 THEN GOTO 253
247	IF CH$>="0" AND CH$<="9" THEN HX%=HX%*16+ASC(CH$)-ASC("0"):GOTO 250
248	IF CH$>="A" AND CH$<="F" THEN HX%=HX%*16+ASC(CH$)-ASC("A")+10:GOTO 250
249	ERTYP%=8:GOTO 67
250	STRG$=STRG$+CHR$(HX%)
251	SMD%=0
252	GOTO 220
253	REM Stringdelimiter
254	IF SMD% <> 4 THEN ERTYP%=6:GOTO 67
255	IF CH$ = CHR$(34) THEN STRG$=STRG$+CH$:GOTO 220
256	RETURN
257	REM
258	REM Test auf korrektes Zeilenende
259	REM -----------------------------
260	REM
261	IF CH$=" " OR CH$=CHR$(9) THEN GOSUB 175
262	IF CH$=";" OR CH$=CHR$(0) THEN RETURN
263	ERTYP%=12:GOTO 71
264	REM
265	REM Einfuegen eines Strings an geeigneter Stelle
266	REM --------------------------------------------
267	REM
268	GOSUB 279:REM Unterprogramm LOCATE
269	REM Einfuegen des STRG$ ab IDX%
270	IF ROM%(IDXPG%*256+IDXOF%) <> 0 THEN ERTYP%=4:GOTO 67
271	GOSUB 310:REM Unterprogramm MOVE
272	ROM%(IDXPG%*256+IDXOF%)=LEN(STRG$)
273	IF LEN(STRG$)=0 THEN GOTO 278
274	FOR I%=1 TO LEN(STRG$)
275	IDXOF%=IDXOF%+1:IF IDXOF%>=256 THEN IDXOF%=2:IDXPG%=IDXPG%+1
276	ROM%(IDXPG%*256+IDXOF%)=ASC(MID$(STRG$,I%,1))
277	NEXT I%
278	RETURN
279	REM
280	REM Unterprogramm LOCATE
281	REM --------------------
282	REM
283	IDXOF%=2+LEVEL%*8+MDE%*2
284	PG%=ROM%(IDXOF%) AND &H1F
285	OF%=ROM%(IDXOF%+1)
286	REM Teste Startbelegung
287	IF (PG% AND &H1F) = 0 AND OF%=34 THEN GOTO 297
288	REM Suche den String
289	IF KEY%=0 THEN GOTO 294
290	FOR I%=1 TO KEY%
291	LN%=ROM%(PG%*256+OF%)+1
292	OF%=OF%+LN%:IF OF%>=256 THEN OF%=OF% MOD 256+2:PG%=PG%+1
293	NEXT I%
294	IDXPG%=PG%
295	IDXOF%=OF%
296	RETURN
297	REM mache Ende der Daten zu neuem Anfang
298	ROM%(IDXOF%)=ROM%(IDXOF%) OR FINPG%
299	ROM%(IDXOF%+1)=FINOF%
300	IF FINOF%+KEY%>=256 THEN GOTO 303
301	IDXOF%=FINOF%+KEY%:IDXPG%=FINPG%
302	GOTO 304
303	IDXOF%=(FINOF%+KEY%) MOD 256+2:IDXPG%=FINPG%+1
304	IF FINOF%+38 >= 256 THEN GOTO 307
305	FINOF%=FINOF%+38
306	GOTO 309
307	FINOF%=(FINOF%+38) MOD 256+2
308	FINPG%=FINPG%+1
309	RETURN
310	REM
311	REM Unterprogramm MOVE
312	REM ------------------
313	REM
314	LN%=LEN(STRG$)
315	IF LN%=0 THEN RETURN
316	SOF%=FINOF%
317	SPG%=FINPG%
318	DPG%=SPG%
319	DOF%=SOF%+LN%:IF DOF%>=256 THEN DOF%=DOF% MOD 256+2:DPG%=DPG%+1
320	IF DPG%*256+DOF% >= 2304 THEN ERTYP%=5:GOTO 67
321	DELT%=(SPG%*256+SOF%)-(IDXPG%*256+IDXOF%)
322	FOR I%=1 TO DELT%
323	ROM%(DPG%*256+DOF%)=ROM%(SPG%*256+SOF%)
324	SOF%=SOF%-1:IF SOF%<2 THEN SOF%=255:SPG%=SPG%-1
325	DOF%=DOF%-1:IF DOF%<2 THEN DOF%=255:DPG%=DPG%-1
326	NEXT I%
327	FOR I%=2 TO 34 STEP 2
328	IF (ROM%(I%) AND &H1F)*256+ROM%(I%+1)<=IDXPG%*256+IDXOF%  THEN GOTO 334
329	IF ROM%(I%+1) <=IDXOF% THEN GOTO 334
330	ROM%(I%+1)=ROM%(I%+1)+LN%
331	IF ROM%(I%+1)<256 THEN GOTO 334
332	ROM%(I%+1)=ROM%(I%+1) MOD 256+2
333	ROM%(I%)=((ROM%(I%) AND &H1F)+1) OR (ROM%(I%) AND &HE0)
334	NEXT I%
335	FINOF%=FINOF%+LN%
336	IF FINOF%>=256 THEN FINOF%=FINOF% MOD 256+2:FINPG%=FINPG%+1
337	RETURN
338	REM
339	REM Initialisieren von ROM%
340	REM -----------------------
341	REM
342	FOR I%=0 TO 2303
343	IF I% MOD 256=0 THEN ROM%(I%)=&HA3:I%=I%+1:ROM%(I%)=&H83:GOTO 345
344	IF I%<34 THEN ROM%(I%)=224 : I%=I%+1 : ROM%(I%)=34 ELSE ROM%(I%)=0
345	NEXT I%
346	FINPG%=0
347	FINOF%=72
348	RETURN
349	REM
350	REM Programmende
351	REM ------------
352	REM
353	END
